
# Copyright (C) Johan Ceuppens 2011
# Copyright (C) Johan Ceuppens 2010

# Copyright (C) Johan Ceuppens 2009 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


import pygame
from pygame.locals import *

from sprite import *

from random import *

class Bomb(Sprite):
    def __init__(self,x,y,w,h):
        Sprite.__init__(self,x,y,w,h)
        self.addimage('bomb1.bmp',0,0,0)
        self.addimage('bomb2.bmp',0,0,0)

        self.addimage('bombexplosion1.bmp',0,0,0)
        self.addimage('bombexplosion2.bmp',0,0,0)

        self.counter = 0

    def drawonmap(self,screen,maproom):
        self.x += maproom.relativex
        self.y += maproom.relativey
        self.draw(screen)
        self.x -= maproom.relativex
        self.y -= maproom.relativey

    def draw(self,screen):

        print 'draw %d' % (self.counter)

        if self.counter >= 100:
            screen.scr.blit(self.images[3], (self.x, self.y))
        elif self.counter >= 90:
            screen.scr.blit(self.images[2], (self.x, self.y))
        elif self.counter >= 85:
            screen.scr.blit(self.images[0], (self.x, self.y))
        elif self.counter >= 80:
            screen.scr.blit(self.images[1], (self.x, self.y))
        elif self.counter >= 75:
            screen.scr.blit(self.images[0], (self.x, self.y))
        elif self.counter >= 70:
            screen.scr.blit(self.images[1], (self.x, self.y))
        elif self.counter >= 65:
            screen.scr.blit(self.images[0], (self.x, self.y))
        elif self.counter >= 60:
            screen.scr.blit(self.images[1], (self.x, self.y))
        else:
            screen.scr.blit(self.images[0], (self.x, self.y))
    

    def update(self,level):
        self.counter += 1
        
        if self.counter > 100:
            level.collisionandremoveenemieswithbomb(self)
            level.entities.remove(self)
