
# Copyright (C) Johan Ceuppens 2011
# Copyright (C) Johan Ceuppens 2010

# Copyright (C) Johan Ceuppens 2009 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


from enemytalking import *
from entity import *
import random
from spellbookdracolich import *
from utility import *

class Dracolich(Enemytalking):#FIXME emytalking):
    "Dungeon 1 boss"
    def __init__(self,x,y,w,h,dungeonnumber,keynumber):#FIXME spellbooknumber
        Enemytalking.__init__(self,x,y,w,h,None)

        self.addimage('dracolich1.bmp',0,0,0)
        self.addimage('dracolich2.bmp',0,0,0)
        self.addimage('dracolich3.bmp',0,0,0)
        self.addimage('dracolich4.bmp',0,0,0)
        self.addimage('dracolich3.bmp',0,0,0)
        self.addimage('dracolich2.bmp',0,0,0)

        self.addimage('dracolichcast1.bmp',0,0,0)
        
        self.counter = 0
        self.direction = "south"
        self.hitpoints = 1

        self.casting = None
        self.castingcounter = 0

        self.dungeonnumber = dungeonnumber
        self.keynumber = keynumber

        self.spellbookx = 100
        self.spellbooky = 100
        self.spellbook = Spellbookdracolich(self.spellbookx,self.spellbooky,80,80,dungeonnumber,keynumber)


    def draw(self,screen):

        r3 = randint(0,450)
        if r3 < 1:
            self.casting = 1

        if self.casting:
            if self.castingcounter < 10:
                self.castingcounter += 1
                screen.scr.blit(self.images[6], (self.x, self.y))
                return

        self.counter += 1

        if self.counter > 70:
            self.counter = 0

        if self.counter < 10:
            screen.scr.blit(self.images[0], (self.x, self.y))
        elif self.counter < 20:
            screen.scr.blit(self.images[1], (self.x, self.y))
        elif self.counter < 30:
            screen.scr.blit(self.images[2], (self.x, self.y))
        elif self.counter < 40:
            screen.scr.blit(self.images[3], (self.x, self.y))
        elif self.counter < 50:
            screen.scr.blit(self.images[4], (self.x, self.y))
        elif self.counter < 60:
            screen.scr.blit(self.images[5], (self.x, self.y))
        else:
            screen.scr.blit(self.images[0], (self.x, self.y))

    def update(self,level):

        if self.casting:
            if self.castingcounter >= 10:
                self.casting = None
                self.castingcounter = 0
                level.summonskeleton(self.x-50,self.y+50)
            


        r = randint(0,100)

        if r < 1:
            r2 = randint(0,3)
            if r2 == 0:
                self.direction = "north"
            if r2 == 1:
                self.direction = "south"
            if r2 == 2:
                self.direction = "west"
            if r2 == 3:
                self.direction = "east"

        if self.collisionlist(self,level.entities) != self or self.collisionlist(self,level.exits) or self.collisionlist(self,level.boxes):#FIXME != self
            print "dracolich entity bounce back"
            self.bounceback()
	    return

        if self.direction == "north":
            self.y -= 1
        if self.direction == "south":
            self.y += 1
        if self.direction == "west":
            self.x -= 1
        if self.direction == "east":
            self.x += 1
        
            

    def bounceback(self):
        if self.direction == "north":
            self.y += 5
            self.direction = "south"
            #self.movedown()
        elif self.direction == "south":
            self.y -= 5
            self.direction = "north"
            #self.moveup()
        elif self.direction == "west":
            self.x += 5
            self.direction = "esst"
            #self.moveright()
        elif self.direction == "east":
            self.x -= 5
            self.direction = "west"
            #self.moveleft()

    def remove(self,list):
#        string = "You have killed boss 1 - dungeon 2\n"




        string = "You have killed boss "
        string += self.keynumber
        string += " - dungeon "
        string += self.dungeonnumber
        string += "\n"
        print "BAR"

            
        s = ""

        if Utilities().readandfindstring(string):
            list.addobject(self.spellbook)
            list.remove(self)
            return None


        if self.hitpoints == 0:

            f = open("./workfile",'r')
            for line in f:
                s += line
                
            f = open("./workfile",'w')
            
            f.write(s)
            f.write(string)
            f.write("\n")

            list.addobject(self.spellbook)
            list.remove(self)

            return 1

    def hit(self):
        self.hitpoints -= self.decreasehp


    def readboss(self,list):
        string = "You have killed boss "
        string += self.keynumber
        string += " - dungeon "
        string += self.dungeonnumber
        string += "\n"

        if Utilities().readandfindstring(string):
            print "+++ boss already neutralised"
#            self.removeallenemies()
            if list:
                list.remove(self)
            return 1

        return None

    def getname(self,text):
        return text.getdracolichname()
    
