
# Copyright (C) Johan Ceuppens 2011
# Copyright (C) Johan Ceuppens 2010

# Copyright (C) Johan Ceuppens 2009 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


from hermit import *
from candleflame1 import *
from candleflame2 import *
from bat import *
from skeleton import *
from skeleton2 import *
from skeletonunderplayercommand import *
from tree2 import *
from tree3 import *
from tree4 import *
from tree5 import *
from ent import *
from chaosknight1 import *
from chaosknight2 import *
from myconid import *
from myconidred import *
from earthweird import *
from koboldmage import *
from shieldmaiden1 import *
from orcpaladin import *
from orcswordsmanblue import *
from angel import *
from hobgoblinswordsman1 import * 
from hobgoblinswordsmanchief1 import * 
from demon1 import *
from movingplatform1 import *
from movingplatformmaproom1 import *
from cherubstatue1 import *
from food import *
from batcrazy import *
from bouncer import *
from knightdark1 import *
from houndarchon import *
from oozebig import *
from waterdevil import *
from waterdevilfemale import *
from treestone import *
from treestonewithcandles import *
from nutter import *
from nutter2 import *
from birdsparrow import *
from trollblack import *
from unicornstatue import *
from unicornstatuelittle import *

class Entityfactory(object):
    
    def makewithboxes(self, entityType,x,y,w,h, boxes):
        classByType = {
            Entity.ENTITY_BOUNCER1 : Bouncer,
            Entity.ENTITY_OOZEBIG1 : Oozebig,
            Entity.ENTITY_WATERDEVIL : Waterdevil,
            Entity.ENTITY_TROLLBLACK : Trollblack,
            Entity.ENTITY_ORCSWORDSMANBLUE : Orcswordsmanblue,
            Entity.ENTITY_CHAOSKNIGHT1 : Chaosknight1,
            Entity.ENTITY_CHAOSKNIGHT2 : Chaosknight2,
        }
        return classByType[entityType](x,y,w,h, boxes)

    def make(self, entityType,x,y,w,h):
        classByType = {
            Entity.ENTITY_BAT: Bat,
            Entity.ENTITY_SKELETON: Skeleton,
            Entity.ENTITY_SKELETON2: Skeleton2,
            Entity.ENTITY_SKELETONUNDERPLAYERCOMMAND: Skeletonunderplayercommand,
            Entity.ENTITY_TREE2 : Tree2,
            Entity.ENTITY_TREE3 : Tree3, 	
            Entity.ENTITY_TREE4 : Tree4, 
            Entity.ENTITY_TREE5 : Tree5, 
            Entity.ENTITY_TREESTONE : Treestone, 
            Entity.ENTITY_ENSORCELLEDTREE : Treestonewithcandles,
            Entity.ENTITY_ENT : Ent,
            Entity.ENTITY_MYCONID : Myconid,
            Entity.ENTITY_MYCONID_RED : Myconidred,
            Entity.ENTITY_EARTHWEIRD : Earthweird,
            Entity.ENTITY_KOBOLDMAGE : Koboldmage,
            Entity.ENTITY_ORCPALADIN : Orcpaladin,
            Entity.ENTITY_HOBGOBLINSWORDSMAN1 : Hobgoblinswordsman1,
            Entity.ENTITY_HOBGOBLINSWORDSMANCHIEF1 : Hobgoblinswordsmanchief1,
            Entity.ENTITY_ANGEL : Angel,
            Entity.ENTITY_DEMON1 : Demon1,
            Entity.ENTITY_PLATFORM1 : Movingplatform1,
            Entity.ENTITY_PLATFORMMAPROOM1 : Movingplatformmaproom1,
            Entity.ENTITY_CHERUBSTATUE1 : Cherubstatue1,
            Entity.ENTITY_FOOD : Food,
            Entity.ENTITY_BATCRAZY : Batcrazy,
            Entity.ENTITY_KNIGHTDARK1 : Knightdark,
            Entity.ENTITY_HOUNDARCHON1 : Houndarchon,
            Entity.ENTITY_WATERDEVILFEMALE : Waterdevilfemale,
            Entity.ENTITY_NUTTER1 : Nutter,
            Entity.ENTITY_NUTTER2 : Nutter2,
            Entity.ENTITY_SPARROW : Birdsparrow,
            Entity.ENTITY_UNICORNSTATUE : Unicornstatue,
            Entity.ENTITY_UNICORNSTATUELITTLE : Unicornstatuelittle,
            Entity.ENTITY_HERMIT : Hermit,
            Entity.ENTITY_CANDLEFLAME1 : Candleflame1,
            Entity.ENTITY_CANDLEFLAME2 : Candleflame2,
            Entity.ENTITY_SHIELDMAIDEN : Shieldmaiden,
        }
        return classByType[entityType](x,y,w,h)

    def add(self,room):
        room.entityfactory = self

