
# Copyright (C) Johan Ceuppens 2011
# Copyright (C) Johan Ceuppens 2010

# Copyright (C) Johan Ceuppens 2009 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


from enemytalking import *
from entity import *
import random
from utility import *
from talksystemkoboldmage import *

class Koboldmage(Enemytalking):#FIXME emytalking):
    "Kobold mage"
    def __init__(self,x,y,w,h):
        Enemytalking.__init__(self,x,y,w,h,Talksystemkoboldmage())

        self.addimage('koboldwizard1.bmp',0,0,0)
        self.addimage('koboldwizardcast1.bmp',0,0,0)
        
#        self.counter = 0
        self.direction = "south"
        self.hitpoints = 1

        self.casting = None
        self.castingcounter = 0

        self.dungeonnumber = "1"#dungeonnumber
        self.keynumber = "1"#keynumber


    def draw(self,screen):

        r3 = randint(0,450)
        if r3 < 1:
            self.casting = 1

        if self.casting:
            if self.castingcounter < 10:
                self.castingcounter += 1
                screen.scr.blit(self.images[1], (self.x, self.y))
                return
        else:
            screen.scr.blit(self.images[0], (self.x, self.y))

    def update(self,level):

        if self.casting:
            if self.castingcounter >= 10:
                self.casting = None
                self.castingcounter = 0
                #FIXME1 relative x y
                level.summonskeleton(self.x-50,self.y+50)
            


        r = randint(0,100)

        if r < 1:
            r2 = randint(0,3)
            if r2 == 0:
                self.direction = "north"
            if r2 == 1:
                self.direction = "south"
            if r2 == 2:
                self.direction = "west"
            if r2 == 3:
                self.direction = "east"

        #FIXME high load collision checks
        if self.collisionlist(self,level.entities) != self or self.collisionlist(self,level.exits) or self.collisionlist(self,level.boxes):#FIXME != self
            print "entity bounce back"
            self.bounceback()
            return

        if self.direction == "north":
            self.y -= 1
        if self.direction == "south":
            self.y += 1
        if self.direction == "west":
            self.x -= 1
        if self.direction == "east":
            self.x += 1
        
            

    def bounceback(self):
        if self.direction == "north":
            self.y += 1
            #self.movedown()
        elif self.direction == "south":
            self.y -= 1
            #self.moveup()
        elif self.direction == "west":
            self.x += 1
            #self.moveright()
        elif self.direction == "east":
            self.x -= 1
            #self.moveleft()

    def remove(self,list):
#        string = "You have killed boss 1 - dungeon 2\n"




        string = "You have killed a kobold mage "
        string += self.keynumber
        string += " - dungeon "
        string += self.dungeonnumber
        string += "\n"

            
        s = ""

        if Utilities().readandfindstring(string):
            list.remove(self)
            return None


        if self.hitpoints == 0:

            f = open("./workfile",'r')
            for line in f:
                s += line
                
            f = open("./workfile",'w')
            
            f.write(s)
            f.write(string)
            f.write("\n")

            list.remove(self)

            return 1

    def hit(self):
        self.hitpoints -= self.decreasehp


    def readkoboldmage(self,list):
        string = "You have killed a kobold mage "
        string += self.keynumber
        string += " - dungeon "
        string += self.dungeonnumber
        string += "\n"

        if Utilities().readandfindstring(string):
            print "+++ kobold mage already neutralised"
#            self.removeallenemies()
            if list:
                list.remove(self)
            return 1

        return None

    def getname(self,text):
        return text.getkoboldmagename()
    
