
# Copyright (C) Johan Ceuppens 2011
# Copyright (C) Johan Ceuppens 2010

# Copyright (C) Johan Ceuppens 2009 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


import pygame
from pygame.locals import *
from room import *
from bomb import *
from maproom import *

class Maproomleftright(Maproom):
    "Room with a (big) map only movable left and right"
    def __init__(self,x,y):
        Room.__init__(self)
        self.relativex = x
        self.relativey = y

    def draw(self,screen):
        screen.scr.blit(self.background, (0+self.relativex, 0+self.relativey))
        screen.drawonmap(self)

    def update(self,player,level,swordplay):
        self.updatelist(self.entities)

        o = player.collisionlistrelative(self.entities,self.relativex,self.relativey)
        if o:
	    if swordplay != 0:
		print("+++++++++++++++SWORDPLAY")
		o.hitpoints -= 1
        	if o.hitpoints <= 0:
            	    self.entities.remove(o)    
	    else:
	        o.dofood(player) 
	    	o.doplatform(player,level)
               	player.bounceback(level)
                o.decreasehpinplayer(player,level)
            	o.remove(self.entities)
     
 
    def moveup(self,player):
        player.direction = "north"
        #self.relativey = self.relativey + 10
	player.y -= 10

    def movedown(self,player):
        player.direction = "south"
        #self.relativey = self.relativey - 10
	player.y += 10

    def moveleft(self,player):
        player.direction = "west"
        self.relativex = self.relativex + 10

    def moveright(self,player):
        player.direction = "east"
        self.relativex = self.relativex - 10
	print ("x=%d y=%d" % (self.relativex, player.y))

    #### COLLISION CODE - OVERRIDING ROOM CODE 


    def processorrelativex(self,o):
        return o.x - self.relativex

#    def processorrelativey(self,o):
#        return o.y - self.relativey

    def collisionlistbombrelative(self,bomb,list):
        for o in list.list:
            if o:
                x = self.processorrelativex(o)
                y = self.processorrelativey(o)
                if x >= bomb.x - bomb.w and x <= bomb.x + bomb.w and y >= bomb.y - bomb.h and y <= bomb.y + bomb.h:
                    return o
        return None

#     def warp(self,x,y):
#         self.relativex = 800
#         self.relativey = 800


    def collisionexits(self,player,roommanager):
        o = player.collisionlistrelative(self.exits, self.relativex, self.relativey)

        if o:
            print 'exit foo x=%d,y=%d px=%d py=%d' % (o.x,o.y,player.x,player.y)
            o.room.loadroom()
            roommanager.room = o.room
            player.warp(o.newx,o.newy)
            return 1
        return None

    def collisionboxes(self,player):
        o = player.collisionlistrelative(self.boxes, self.relativex, self.relativey)
        if o:
            #player.bounceback()
            return 1
        return None


    def collisionandremoveenemieswithbomb(self, bomb):

        b = Bomb(self.processorrelativex(bomb),self.processorrelativey(bomb),80,80)
#        bomb.x = self.processorrelativex(bomb.x)
#        bomb.y = self.processorrelativey(bomb.y)
        o = self.collisionlistbombrelative(b,self.entities)
        if o:
            o.hit()
            o.remove(self.entities)
            self.entities.remove(o)
            
#     def summonskeletonunderplayercommand(self,x,y):
#         self.addenemy(Skeletonunderplayercommand(x,y,50,50))


    def summonskeleton(self,x,y):
        self.addenemy(Skeleton2(x-self.relativex,y-self.relativey,50,50))


    # Dropping bomb entities
    def addsprite(self,sprite):
        sprite.x -= self.relativex
        sprite.y -= self.relativey
        self.addentity(sprite)


    def collisionplayerrelative(self,mouse,player,relx,rely):
        mouse.collisionplayerrelative(player,relx,rely)

    def domouse(self,game):
        # Collide mouse with player
        p = game.domouseonplayerrelative(self)#game.collisionplayerrelative(self)
        if p:
            foo = game.leftbuttonpressed(game.player)
            if foo:
                return
            
        # Collide mouse with entities
        o = None
        o = game.collisionlistrelativeonmouse(self.entities,self.relativex,self.relativey)
        if o:
            foo = game.mouse.leftbuttonpressed(o,game)
#            print foo
            if foo:
                game.screen.scr.blit(game.font.render(foo, 16, (255,255,255)), (10,10))
#                print foo
            else:
                game.screen.scr.blit(game.font.render(o.getname(game.text), 10, (0,0,0)), (game.mouse.x+10,game.mouse.y))
#            mouse.middlebuttonpressed(o,text)
#            mouse.rightbuttonpressed(o,text)
            
                
    def domouseinventory(self,game):#,screen,mouse,font,text,item,player):
        # Collide mouse with player
        p = game.domouseonplayerrelative(self)
        if p:
            foo = game.mouse.leftbuttonpressedwithinventoryitem(game.player,game)
            if foo:
                return 1

        # Collide mouse with entities
        o = None
        o = game.collisionlistrelativeonmouse(self.entities,self.relativex,self.relativey)
        if o and game.inventoryitem:
            foo = game.mouse.leftbuttonpressedwithinventoryitem(o,game)#.text,game.inventoryitem)
            if foo:
                return 1

        if not o and game.mouse.press(0):
            return 1

        return None

