
# Copyright (C) Johan Ceuppens 2011
# Copyright (C) Johan Ceuppens 2010

# Copyright (C) Johan Ceuppens 2009 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


import pygame
from pygame.locals import *
from bomb import *

from entity import *

class Player:
    "Player"
    def __init__(self):
	#Entity.__init__(self,200,210,50,50)
        self.x = 200#400
        self.y = 210#100
        self.w = 50
        self.h = 50
        self.direction = "north"
        self.images = []
        self.image1 = pygame.image.load('player1-50x50.bmp').convert()
        self.image2 = pygame.image.load('player2-50x50.bmp').convert()
        self.image3 = pygame.image.load('player1-50x50.bmp').convert()
        self.image4 = pygame.image.load('player3-50x50.bmp').convert()
        self.image5 = pygame.image.load('playerwithswordleft1.bmp').convert()
        self.image6 = pygame.image.load('playerwithsword1.bmp').convert()

        self.image1.set_colorkey((255,255,255)) 
        self.image2.set_colorkey((255,255,255)) 
        self.image3.set_colorkey((255,255,255)) 
        self.image4.set_colorkey((255,255,255)) 
        self.image5.set_colorkey((255,255,255)) 
        self.image6.set_colorkey((255,255,255)) 

        self.lifeimage = pygame.image.load('life1.bmp').convert()
        self.lifeimage.set_colorkey((255,255,255)) 

        self.imageindex = 0

        self.addimages()

        self.bombidcounter = 10000

        self.hitpoints = 30 
        self.decreasehitpoints = 1

        self.talkcounter = 0
        self.currenttext = ""

        self.blackimage1 = pygame.image.load('player1-madblack-50x50.bmp').convert()
        self.blackimage1.set_colorkey((255,255,255)) 
        self.black = None
        self.madcounter = 0
	self.invisible = 0

    def drawlife(self, screen):
 	i = self.hitpoints 
	while i > 0:
	   i -= 1
           screen.scr.blit(self.lifeimage, (10+i*10,0))
	    
	     

    def addimages(self):
        self.images.append(self.image1)
        self.images.append(self.image2)
        self.images.append(self.image3)
        self.images.append(self.image4)
        self.images.append(self.image5)
        self.images.append(self.image6)

    def warp(self,x,y):
        self.x = x
        self.y = y


    def moveupanddirect(self,level):
        level.roommanager.room.moveup(self)

    def movedownanddirect(self,level):
        level.roommanager.room.movedown(self)

    def moveleftanddirect(self,level):
        level.roommanager.room.moveleft(self)

    def moverightanddirect(self,level):
        level.roommanager.room.moveright(self)


    def moveupanddirect1(self):
        self.direction = "north"
        self.y = self.y - 12
        self.imageindex = self.imageindex + 1

    def movedownanddirect1(self):
        self.direction = "south"
        self.y = self.y + 12
        self.imageindex = self.imageindex + 1

    def moveleftanddirect1(self):
        self.direction = "west"
        self.x = self.x - 12
        self.imageindex = self.imageindex + 1

    def moverightanddirect1(self):
        self.direction = "east"
        self.x = self.x + 12
        self.imageindex = self.imageindex + 1

    def moveup(self):
        self.y = self.y - 12

    def movedown(self):
        self.y = self.y + 12

    def moveleft(self):
        self.x = self.x - 12

    def moveright(self):
        self.x = self.x + 12


    def bounceback(self,level):
        if self.direction == "north":
            self.movedownanddirect(level)
            #self.movedown()
        elif self.direction == "south":
            self.moveupanddirect(level)
            #self.moveup()
        elif self.direction == "west":
            self.moverightanddirect(level)
            #self.moveright()
        elif self.direction == "east":
            self.moveleftanddirect(level)
            #self.moveleft()


    def draw(self):
        self.imageindex = self.imageindex + 1
	if self.invisible:
            if self.imageindex > 3:
                self.imageindex = 0
            return self.images[self.imageindex]

        if self.black:
            r = randint(0,100)
            if r < 1 or self.madcounter >= 1:
                self.madcounter += 1

                if self.madcounter >= 10:
                    self.madcounter = 0

                return self.blackimage1
 
        if self.imageindex > 3:
            self.imageindex = 0

        return self.images[self.imageindex]
       
    def drawswordleft(self):
	return self.images[4]	 
    
    def drawswordright(self):
	return self.images[5]	 

    def dropbomb(self,level):
        level.roommanager.room.addsprite(Bomb(self.x,self.y,80,80))

    def decreasehp(self,level):
	print ("player is hit!")
        self.hitpoints -= self.decreasehitpoints

        if self.hitpoints <= 0:
            level.setgameover()
    
    def increasehp(self):
	if self.hitpoints < 30:
            self.hitpoints += 5 

    def collisionplayer(self,mouse):
        if mouse.x >= self.x and mouse.x <= self.x + self.w and mouse.y >= self.y and mouse.y <= self.y + self.h:   	
              return self
        return None

    def processorrelativex(self,o,relx):
        return o.x - relx

    def processorrelativey(self,o,rely):
        return o.y - rely

    def collisionplayerrelative(self,mouse,relx,rely):
        px = self.processorrelativex(self,relx)
        py = self.processorrelativey(self,rely)

        x = self.processorrelativex(mouse, relx)
        y = self.processorrelativey(mouse, rely)
        if x >= px and x <= px + self.w and y >= py and y <= py + self.h:   	
              return self
        return None

    def collisionlistsword(self,list):
        return self.collisionlist2(self,list)

    def collisionlist(self,list):
        return self.collisionlist1(self,list)

    # GEN PROC
    def collisionlist1(self,collider,list):
        for i in range(0,list.length):
            o = None
            o = list.getlistobject(o)
            
            if o:
#                print 'i=%d x=%d y=%d px=%d py=%d' % (i, o.x,o.y,collider.x,collider.y)
                if collider.x >= o.x and collider.x <= o.x + o.w and collider.y >= o.y and collider.y <= o.y + o.h:   	
                    return o
        return None

	# SWORD COLLISON
    def collisionlist2(self,collider,list):
        for i in range(0,list.length):
            o = None
            o = list.getlistobject(o)
            
            if o:
#                print 'i=%d x=%d y=%d px=%d py=%d' % (i, o.x,o.y,collider.x,collider.y)
                if collider.x+30 >= o.x and collider.x <= o.x + o.w+30 and collider.y +30>= o.y and collider.y <= o.y + o.h +30:   	
                    return o
        return None

    #FIXME put in Utitlities
    def processorrelativex(self,o,relx):
        return o.x - relx

    def processorrelativey(self,o,rely):
        return o.y - rely
    
    def collisionlistrelative(self,list,relx,rely):
        return self.collisionlistrelative1(self,list,relx,rely)

    # GEN PROC
    def collisionlistrelative1(self,collider,list,relx,rely):
        for i in range(0,list.length):
            o = None
            o = list.getlistobject(o)

            if o:
       
                #FIXME1 o.x <-> self.relativex
                x = o.x - 12#self.processorrelativex(o,relx)
                y = o.y - 12#self.processorrelativey(o,rely)
                px = self.processorrelativex(self,relx)
                py = self.processorrelativey(self,rely)

#                print 'i=%d x=%d y=%d px=%d py=%d' % (i, o.x,o.y,px,py)
		# NOTE : +24 for better sword collision
                if px + 12 >= x and px <= x + o.w + 12 and py + 12 >= y and py <= y + o.h + 12:   	
                    return o
        return None

    def leftbuttonpressed(self,game):
        if game.mouse.press(0) == 1:
            self.talkcounter += 1
            #print "keypress on player"
            if self.talkcounter == 1:
                1#self.currenttext = self.talksystem.gettalk(text)#foo
            return self.currenttext
        else:
            self.talkcounter = 0 	
            return self.currenttext


    def leftbuttonpressedwithinventoryitem(self,game):#mouse,text,press0,item):
        if game.mouse.press(0) == 1:
            self.talkcounter += 1
            #print "keypress with item on player"
            if game.inventoryitem:
                game.inventoryitem.use(self,game)
            return 1
        else:
            self.talkcounter = 0 	
            return None#self.currenttext

#        print "+++ left button press on player"
#        return None

    def usedracolichspellbook(self,game):
	print("You use the dracolich spellbook.")
        self.setblackplayer(game)
        x = randint(0,500)
        y = randint(0,300)
        game.level.roommanager.room.summonskeletonunderplayercommand(x,y)

    def usescrollinvisibility(self,game):
	print("You become invisible.")
        self.setinvisibleplayer(game)

    def setblackplayer(self,game):

        self.black = 1
        self.madcounter = 0

        self.images = []
        self.image1 = pygame.image.load('player1-black-50x50.bmp').convert()
        self.image2 = pygame.image.load('player2-black-50x50.bmp').convert()
        self.image3 = pygame.image.load('player1-black-50x50.bmp').convert()
        self.image4 = pygame.image.load('player3-black-50x50.bmp').convert()

        self.image1.set_colorkey((255,255,255)) 
        self.image2.set_colorkey((255,255,255)) 
        self.image3.set_colorkey((255,255,255)) 
        self.image4.set_colorkey((255,255,255)) 

        self.addimages()



    def setinvisibleplayer(self,game):
	print ("set invisibile player")
        self.invisible = 1

        self.images = []
        self.image1 = pygame.image.load('playerinvisible1-50x50.bmp').convert()
        self.image2 = pygame.image.load('playerinvisible2-50x50.bmp').convert()
        self.image3 = pygame.image.load('playerinvisible3-50x50.bmp').convert()

        self.image1.set_colorkey((255,255,255)) 
        self.image2.set_colorkey((255,255,255)) 
        self.image3.set_colorkey((255,255,255)) 

        self.addimages()

