
# Copyright (C) Johan Ceuppens 2011
# Copyright (C) Johan Ceuppens 2010

# Copyright (C) Johan Ceuppens 2009 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


from enemy import *
import random

class Skeleton2(Enemy):
    def __init__(self,x,y,w,h):
        Enemy.__init__(self,x,y,w,h)

        self.addimage('skeleton1.bmp',0,0,0)
        self.addimage('skeleton2.bmp',0,0,0)
        self.addimage('skeleton3.bmp',0,0,0)
        self.addimage('skeleton4.bmp',0,0,0)
        self.addimage('skeleton5.bmp',0,0,0)

        self.counter = 0
        self.direction = "south"

    def getname(self,text):
        return text.getskeletonname()

    def draw(self,screen):
        self.counter += 1

        if self.counter > 60:
            self.counter = 0

        if self.counter < 10:
            screen.scr.blit(self.images[0], (self.x, self.y))
        elif self.counter < 20:
            screen.scr.blit(self.images[1], (self.x, self.y))
        elif self.counter < 30:
            screen.scr.blit(self.images[2], (self.x, self.y))
        elif self.counter < 40:
            screen.scr.blit(self.images[3], (self.x, self.y))
        elif self.counter < 50:
            screen.scr.blit(self.images[4], (self.x, self.y))
        else:
            screen.scr.blit(self.images[0], (self.x, self.y))

    def update(self,level):

        r = randint(0,100)

        if r < 1:

            r2 = randint(0,3)
            if r2 == 0:
                self.direction = "north"
            if r2 == 1:
                self.direction = "south"
            if r2 == 2:
                self.direction = "west"
            if r2 == 3:
                self.direction = "east"


        if self.collisionlist(self,level.entities) != self or self.collisionlist(self,level.exits) or self.collisionlist(self,level.boxes):
            # FIXME colliision with self
            
#            print "entity bounce back"
            self.bounceback()
            self.bounceback()
            self.bounceback()
            r3 = randint(0,3)
            if r3 == 0:
                self.direction = "north"
            if r3 == 1:
                self.direction = "south"
            if r3 == 2:
                self.direction = "west"
            if r3 == 3:
                self.direction = "east"


        if self.direction == "north":
            self.y -= 1
        if self.direction == "south":
            self.y += 1
        if self.direction == "west":
            self.x -= 1
        if self.direction == "east":
            self.x += 1
        
    def bounceback(self):
        if self.direction == "north":
            self.y += 1
            #self.movedown()
        elif self.direction == "south":
            self.y -= 1
            #self.moveup()
        elif self.direction == "west":
            self.x += 1
            #self.moveright()
        elif self.direction == "east":
            self.x -= 1
            #self.moveleft()

    def isskeleton(self):
        return 1
