
# Copyright (C) Johan Ceuppens 2011
# Copyright (C) Johan Ceuppens 2010

# Copyright (C) Johan Ceuppens 2009 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


from enemy import *


# Player's skeleton
class Skeletonunderplayercommand(Enemy):
    def __init__(self,x,y,w,h):
        Enemy.__init__(self,x,y,w,h)

        self.addimage('skeleton1.bmp',0,0,0)
        self.addimage('skeleton2.bmp',0,0,0)
        self.addimage('skeleton3.bmp',0,0,0)
        self.addimage('skeleton4.bmp',0,0,0)
        self.addimage('skeleton5.bmp',0,0,0)

        self.counter = 0

    def getname(self,text):
        return text.getskeletonofplayername()

    def draw(self,screen):
        self.counter += 1

        if self.counter > 60:
            self.counter = 0

        if self.counter < 10:
            screen.scr.blit(self.images[0], (self.x, self.y))
        elif self.counter < 20:
            screen.scr.blit(self.images[1], (self.x, self.y))
        elif self.counter < 30:
            screen.scr.blit(self.images[2], (self.x, self.y))
        elif self.counter < 40:
            screen.scr.blit(self.images[3], (self.x, self.y))
        elif self.counter < 50:
            screen.scr.blit(self.images[4], (self.x, self.y))
        else:
            screen.scr.blit(self.images[0], (self.x, self.y))


    def update(self,level):

        # seek and destroy
        
        e = level.entities.getwithindex(0)#FIXME 0

        if e and not e.isplayerskeleton():
            if self.x <= e.x:
                self.x += 1
            if self.x >= e.x:
                self.x -= 1
            if self.y <= e.y:
                self.y += 1
            if self.y >= e.y:
                self.y -= 1
        
            o = None
            o = self.collisionlist(e,level.entities)

            if o and e != o:
                o.hit()
                e.hit()
                e.remove(level.entities)
                o.remove(level.entities)
                #FIXME level.entities.remove(e)
                return

#    def hit(self):
#            print "hit on your skeleton" 
#            self.hitpoints -= self.decreasehp

#     def remove(self,list):
#         if self.hitpoints <= 0:
#             list.remove(self)

#FIXME
    def bounceback(self):

        print "+++ bounce back"
#        print self.direction

        if self.direction == "north":
            #print self.y
            self.y += 5
            #self.movedown()
        elif self.direction == "south":
            self.y -= 5
            #self.moveup()
        elif self.direction == "west":
            self.x += 5
            #self.moveright()
        elif self.direction == "east":
            self.x -= 5
            #self.moveleft()

    def isplayerskeleton(self):
        return 1
